#!/usr/bin/perl
require v5.8.8;
use warnings;
use strict;
use encoding 'utf8', STDOUT => 'utf8'; # для windows значение STDOUT => 'cp1251', современные ОС STDOUT => 'utf8', для ActivePerl STDOUT => 'cp866'
$| = 1;
$\ = "\n"; # символ, который print добавляет после вывода всех аргументов

die 'You must specify a file for validation: '. $0 .' <input_file_1.xml ... <input_file_N.xml>' if !@ARGV;

my ($all_lines, $error_lines);

foreach (@ARGV){

my $input_file = shift;

open (INPUT,'<',$input_file) or die "Can't open $input_file: $!";

	my $line1 = <INPUT>;
	
	while (my $line2 = <INPUT>){
		$all_lines++;
		
		chomp $line2;
		$line2 =~ s/\s{2,}/ /g;
		next unless length ($line2);
		$line1 .= $line2;
 
			while ($line1 =~ m#<(\w+)\s?\w*=?"?\w*"?>\s*</\1>$#ig){
				if ($1 !~ /axle|brand/i){
					$error_lines++;
					print $input_file .', line '. $. .': '. $& .' - tag is empty!';
				}
			}
		
		$line1 = $line2;
	}

close (INPUT);

}

$error_lines = 0 if !$error_lines;
# print 'Всего обработано строк: '. $all_lines .', из них с ошибками: '. $error_lines .'. Процент ошибок: '. ($error_lines/$all_lines)*100*2; # на 2 умножаем, т.к. ошибка - это 2 строки (открытый и закрытый тег). можно делить на 2 общее число строк в принципе.
print 'Всего обработано тегов: '. $all_lines/2 .', из них содержат ошибки: '. $error_lines .'. Процент ошибок: '. ($error_lines/($all_lines/2))*100;

exit 0;
